import { ReactNode } from 'react';
import { History, MemoryHistoryOptions } from 'history';
import type { Route, Location, RouterInstance } from '../types';
import defaultResolve from '../resolve-view';
export declare const RouterContext: import("react").Context<RouterInstance<Route, ReactNode> | null>;
declare type HistoryState = {
    locationStack: Location[];
    index?: number;
} | null;
declare type Props = {
    children: ReactNode;
    routes: Route[] | Route;
    baseUrl?: string;
    resolveView?: typeof defaultResolve;
    errorHandler?: (error: Error) => ReactNode;
};
export declare function BaseRouter(props: Props & {
    history: History<HistoryState>;
}): JSX.Element;
declare function RouterComponent(props: Props): JSX.Element;
export { RouterComponent as Router };
export declare function HashRouter(props: Props): JSX.Element;
export declare function MemoryRouter({ initialEntries, initialIndex, ...props }: Props & MemoryHistoryOptions): JSX.Element;
export declare function useRouter(): RouterInstance<Route, ReactNode>;
