import { createContext, useState, useContext, useMemo, useEffect, useRef } from 'react';
import { jsx, Fragment } from 'react/jsx-runtime';
import { parsePath, createPath, createBrowserHistory, createHashHistory, createMemoryHistory } from 'history';
import { match as match$1 } from 'path-to-regexp';

function _toConsumableArray$1(arr) { return _arrayWithoutHoles$1(arr) || _iterableToArray$1(arr) || _unsupportedIterableToArray$5(arr) || _nonIterableSpread$1(); }

function _nonIterableSpread$1() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray$1(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles$1(arr) { if (Array.isArray(arr)) return _arrayLikeToArray$5(arr); }

function _slicedToArray$5(arr, i) { return _arrayWithHoles$5(arr) || _iterableToArrayLimit$5(arr, i) || _unsupportedIterableToArray$5(arr, i) || _nonIterableRest$5(); }

function _nonIterableRest$5() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray$5(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$5(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$5(o, minLen); }

function _arrayLikeToArray$5(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit$5(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles$5(arr) { if (Array.isArray(arr)) return arr; }
function createStateContext() {
  for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
    params[_key] = arguments[_key];
  }

  var ValueContext = /*#__PURE__*/createContext(undefined);
  var SetterContext = /*#__PURE__*/createContext(undefined);

  function Provider(_ref) {
    var children = _ref.children;

    var _useState = useState.apply(void 0, _toConsumableArray$1(params)),
        _useState2 = _slicedToArray$5(_useState, 2),
        value = _useState2[0],
        setValue = _useState2[1];

    return /*#__PURE__*/jsx(SetterContext.Provider, {
      value: setValue,
      children: /*#__PURE__*/jsx(ValueContext.Provider, {
        value: value,
        children: children
      })
    });
  }

  return {
    SetterContext: SetterContext,
    ValueContext: ValueContext,
    Provider: Provider
  };
}
function useValueContext(Ctx) {
  return useContext(Ctx.ValueContext);
}
function useSetterContext(Ctx) {
  return useContext(Ctx.SetterContext);
}

function _slicedToArray$4(arr, i) { return _arrayWithHoles$4(arr) || _iterableToArrayLimit$4(arr, i) || _unsupportedIterableToArray$4(arr, i) || _nonIterableRest$4(); }

function _nonIterableRest$4() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray$4(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$4(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$4(o, minLen); }

function _arrayLikeToArray$4(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit$4(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles$4(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys$4(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$4(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$4(Object(source), true).forEach(function (key) { _defineProperty$4(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$4(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$4(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var ViewContext = /*#__PURE__*/createContext(null);
function ViewProvider(props) {
  return /*#__PURE__*/jsx(ViewContext.Provider, _objectSpread$4({}, props));
}
function useView() {
  return useContext(ViewContext);
}
function View() {
  var view = useView();
  return /*#__PURE__*/jsx(Fragment, {
    children: view
  });
}
var DataContext = /*#__PURE__*/createContext([undefined, {}]);
function useDataContext() {
  return useContext(DataContext);
}
function useNamedData() {
  return useDataContext()[1];
}
function DataProvider(_ref) {
  var children = _ref.children,
      name = _ref.name,
      data = _ref.data;
  var namedData = useNamedData();
  return /*#__PURE__*/jsx(DataContext.Provider, {
    value: [data, name ? _objectSpread$4(_objectSpread$4({}, namedData), {}, _defineProperty$4({}, name, data)) : namedData],
    children: children
  });
}
function useData(name) {
  var _useDataContext = useDataContext(),
      _useDataContext2 = _slicedToArray$4(_useDataContext, 2),
      data = _useDataContext2[0],
      namedData = _useDataContext2[1];

  return name ? namedData[name] : data;
}
var LoadingContext = createStateContext();
function useLoading() {
  return useValueContext(LoadingContext);
}
function useLoadingSetter() {
  return useSetterContext(LoadingContext);
}

var i = 1;
function uniqId() {
  return i++;
}
function noop() {}
function cancelPromise() {
  return new Promise(noop);
}
function createCurrentGuard() {
  var current;
  return [function currentGuard(promise) {
    var cur = uniqId();
    current = cur;
    return promise.then(function (result) {
      return current === cur ? result : cancelPromise();
    }).catch(function (err) {
      return current === cur ? Promise.reject(err) : cancelPromise();
    });
  }, function cancel() {
    current = undefined;
  }];
}

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray$3(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray$3(arr); }

function ownKeys$3(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$3(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$3(Object(source), true).forEach(function (key) { _defineProperty$3(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$3(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$3(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray$3(arr, i) { return _arrayWithHoles$3(arr) || _iterableToArrayLimit$3(arr, i) || _unsupportedIterableToArray$3(arr, i) || _nonIterableRest$3(); }

function _nonIterableRest$3() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray$3(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$3(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$3(o, minLen); }

function _arrayLikeToArray$3(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit$3(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles$3(arr) { if (Array.isArray(arr)) return arr; }
function create(routes, history, resolveView, options) {
  var _createCurrentGuard = createCurrentGuard(),
      _createCurrentGuard2 = _slicedToArray$3(_createCurrentGuard, 2),
      currentGuard = _createCurrentGuard2[0],
      cancelAll = _createCurrentGuard2[1];

  return _objectSpread$3(_objectSpread$3({
    routes: Array.isArray(routes) ? routes : [routes],
    resolveView: resolveView,
    history: history,
    locationStack: [],
    viewStack: [],
    currentGuard: currentGuard,
    cancelAll: cancelAll
  }, options), {}, {
    baseUrl: (options === null || options === void 0 ? void 0 : options.baseUrl) || ''
  });
}
function match(router, pathname) {
  function matchRoutes(routes, baseUrl, // eslint-disable-next-line @typescript-eslint/no-shadow
  pathname) {
    for (var i = 0; i < routes.length; i++) {
      var route = routes[i];
      var end = !route.children;
      var matched = route.path ? match$1(route.path, {
        strict: true,
        sensitive: true,
        decode: typeof decodeURIComponent === 'function' ? decodeURIComponent : undefined,
        end: end
      })(pathname) : {
        path: '',
        index: 0,
        params: {}
      };

      if (matched) {
        var result = _objectSpread$3({
          route: route
        }, matched);

        if (end) return [result];
        var children = matchRoutes(route.children, "".concat(baseUrl).concat(route.path || ''), pathname.slice(matched.path.length));
        if (children) return [result].concat(_toConsumableArray(children));
        return undefined;
      }
    }

    return undefined;
  }

  return matchRoutes(router.routes, router.baseUrl, pathname.slice(router.baseUrl.length));
}
function toLocation(router, to, state) {
  var baseUrl = router.baseUrl;
  return _objectSpread$3(_objectSpread$3({
    pathname: '',
    search: '',
    hash: ''
  }, parsePath(baseUrl + to)), {}, {
    state: state
  });
}
function resolve(router, location) {
  var matched = match(router, location.pathname);
  if (!matched) return Promise.reject(new Error('Not Found'));
  var resolveView = router.resolveView;
  return resolveView(matched, {
    router: router,
    location: location
  }).catch(router.errorHandler);
}
function resolveTo(router, to, state) {
  var location = toLocation(router, to, state);
  return resolve(router, location);
}
function commit(router, resolvePromise, location) {
  var _history$location$sta;

  var history = router.history,
      currentGuard = router.currentGuard,
      _router$onLoadingChan = router.onLoadingChange,
      onLoadingChange = _router$onLoadingChan === void 0 ? noop : _router$onLoadingChan;
  var nextIndex = (((_history$location$sta = history.location.state) === null || _history$location$sta === void 0 ? void 0 : _history$location$sta.index) || 0) + 1;

  if (router.resolving) {
    onLoadingChange();
  }

  router.resolving = location;
  onLoadingChange('pending');
  return currentGuard(resolvePromise).then(function (resolvedView) {
    router.locationStack = [].concat(_toConsumableArray(router.locationStack.slice(0, nextIndex)), [location]);
    router.viewStack = [].concat(_toConsumableArray(router.viewStack.slice(0, nextIndex)), [resolvedView]);
    history.push(location, {
      index: nextIndex,
      locationStack: router.locationStack
    });
    onLoadingChange('resolved');
  }).catch(function (e) {
    onLoadingChange('rejected');
    throw e;
  });
}
function commitReplace(router, resolvePromise, location) {
  var _history$location$sta2;

  var history = router.history,
      currentGuard = router.currentGuard,
      _router$onLoadingChan2 = router.onLoadingChange,
      onLoadingChange = _router$onLoadingChan2 === void 0 ? noop : _router$onLoadingChan2;
  var index = ((_history$location$sta2 = history.location.state) === null || _history$location$sta2 === void 0 ? void 0 : _history$location$sta2.index) || 0;

  if (router.resolving) {
    onLoadingChange();
  }

  router.resolving = location;
  onLoadingChange('pending');
  return currentGuard(resolvePromise).then(function (resolvedView) {
    router.locationStack[index] = location;
    router.viewStack[index] = resolvedView;
    history.replace(location, {
      index: index,
      locationStack: router.locationStack
    });
    onLoadingChange('resolved');
  }).catch(function (e) {
    onLoadingChange('rejected');
    throw e;
  });
}
function navigate(router, to, state) {
  var location = toLocation(router, to, state);
  var viewPromise = resolve(router, location);
  return commit(router, viewPromise, location);
}
function refresh(router) {
  var location = router.history.location;
  var viewPromise = resolve(router, location);
  return commitReplace(router, viewPromise, location);
}
function go(router, delta) {
  router.history.go(delta);
}
function forward(router) {
  router.history.forward();
}
function back(router) {
  router.history.back();
}
function createHref(_ref, to) {
  var baseUrl = _ref.baseUrl,
      history = _ref.history;
  return baseUrl + history.createHref(to);
}
function cancel(_ref2) {
  var cancelAll = _ref2.cancelAll,
      _ref2$onLoadingChange = _ref2.onLoadingChange,
      onLoadingChange = _ref2$onLoadingChange === void 0 ? noop : _ref2$onLoadingChange;
  cancelAll();
  onLoadingChange();
}
function listen(router, onViewChange) {
  var _history$location$sta3;

  var _router$onLoadingChan3 = router.onLoadingChange,
      onLoadingChange = _router$onLoadingChan3 === void 0 ? noop : _router$onLoadingChan3,
      history = router.history;
  var locationStack = ((_history$location$sta3 = history.location.state) === null || _history$location$sta3 === void 0 ? void 0 : _history$location$sta3.locationStack) || [history.location];
  router.locationStack = locationStack;
  onLoadingChange('pending');
  Promise.all(locationStack.map(function (l) {
    return resolve(router, l);
  })).then(function (views) {
    router.viewStack = views;
    history.replace(createPath(history.location), history.location.state);
    onLoadingChange('resolved');
  }).catch(function (e) {
    onLoadingChange('rejected');
    throw e;
  });
  var rmListener = history.listen(function (_ref3) {
    var _location$state;

    var action = _ref3.action,
        location = _ref3.location;
    cancel(router);
    var index = ((_location$state = location.state) === null || _location$state === void 0 ? void 0 : _location$state.index) || 0;
    onViewChange(router.viewStack[index]);

    if (action === 'POP') {
      history.replace(createPath(history.location), _objectSpread$3(_objectSpread$3({}, history.location.state), {}, {
        locationStack: router.locationStack
      }));
    }
  });
  return function () {
    cancel(router);
    rmListener();
  };
}

function _slicedToArray$2(arr, i) { return _arrayWithHoles$2(arr) || _iterableToArrayLimit$2(arr, i) || _unsupportedIterableToArray$2(arr, i) || _nonIterableRest$2(); }

function _nonIterableRest$2() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray$2(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$2(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$2(o, minLen); }

function _arrayLikeToArray$2(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit$2(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles$2(arr) { if (Array.isArray(arr)) return arr; }
function resolveView(matched, _ref) {
  var router = _ref.router,
      location = _ref.location;
  return Promise.all(matched.map(function (_ref2, index) {
    var _route$data;

    var params = _ref2.params,
        route = _ref2.route;
    var ctx = {
      matched: matched,
      index: index,
      router: router,
      location: location
    };

    function resolveComponent() {
      if (!route.component) return View;
      var r = route.component(params, ctx);
      return Promise.resolve(r).then(function (m) {
        return 'default' in m ? m.default : m;
      });
    }

    return Promise.all([(_route$data = route.data) === null || _route$data === void 0 ? void 0 : _route$data.call(route, params, ctx), resolveComponent()]).then(function (_ref3) {
      var _ref4 = _slicedToArray$2(_ref3, 2),
          data = _ref4[0],
          C = _ref4[1];

      return /*#__PURE__*/jsx(DataProvider, {
        data: data,
        name: route.name,
        children: /*#__PURE__*/jsx(C, {})
      });
    });
  })).then(function (views) {
    return views.reverse().reduce(function (acc, view) {
      return /*#__PURE__*/jsx(ViewProvider, {
        value: acc,
        children: view
      });
    });
  });
}

var _excluded$2 = ["initialEntries", "initialIndex"];

function _objectWithoutProperties$2(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose$2(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose$2(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys$2(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$2(Object(source), true).forEach(function (key) { _defineProperty$2(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$2(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$2(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray$1(arr, i) { return _arrayWithHoles$1(arr) || _iterableToArrayLimit$1(arr, i) || _unsupportedIterableToArray$1(arr, i) || _nonIterableRest$1(); }

function _nonIterableRest$1() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray$1(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray$1(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray$1(o, minLen); }

function _arrayLikeToArray$1(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit$1(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles$1(arr) { if (Array.isArray(arr)) return arr; }
var RouterContext = /*#__PURE__*/createContext(null);

function BRouter(_ref) {
  var routes = _ref.routes,
      history = _ref.history,
      children = _ref.children,
      _ref$errorHandler = _ref.errorHandler,
      errorHandler = _ref$errorHandler === void 0 ? Promise.reject : _ref$errorHandler,
      baseUrl = _ref.baseUrl,
      _ref$resolveView = _ref.resolveView,
      resolveView$1 = _ref$resolveView === void 0 ? resolveView : _ref$resolveView;
  var setLoading = useLoadingSetter();
  var router = useMemo(function () {
    return create(routes, history, resolveView$1, {
      baseUrl: baseUrl,
      errorHandler: errorHandler,
      onLoadingChange: function onLoadingChange(status) {
        setLoading(status && {
          key: uniqId(),
          status: status
        });
      }
    });
  }, [routes, history, resolveView$1, baseUrl, errorHandler]);

  var _useState = useState(),
      _useState2 = _slicedToArray$1(_useState, 2),
      view = _useState2[0],
      setView = _useState2[1];

  useEffect(function () {
    return listen(router, setView);
  }, [router]);
  return /*#__PURE__*/jsx(RouterContext.Provider, {
    value: router,
    children: typeof children === 'undefined' ? view : /*#__PURE__*/jsx(ViewProvider, {
      value: view,
      children: children
    })
  });
}

function BaseRouter(props) {
  return /*#__PURE__*/jsx(LoadingContext.Provider, {
    children: /*#__PURE__*/jsx(BRouter, _objectSpread$2({}, props))
  });
}

function RouterComponent(props) {
  var history = createBrowserHistory();
  return /*#__PURE__*/jsx(BaseRouter, _objectSpread$2(_objectSpread$2({}, props), {}, {
    history: history
  }));
}
function HashRouter(props) {
  var history = createHashHistory();
  return /*#__PURE__*/jsx(BaseRouter, _objectSpread$2(_objectSpread$2({}, props), {}, {
    history: history
  }));
}
function MemoryRouter(_ref2) {
  var initialEntries = _ref2.initialEntries,
      initialIndex = _ref2.initialIndex,
      props = _objectWithoutProperties$2(_ref2, _excluded$2);

  var history = createMemoryHistory({
    initialEntries: initialEntries,
    initialIndex: initialIndex
  });
  return /*#__PURE__*/jsx(BaseRouter, _objectSpread$2(_objectSpread$2({}, props), {}, {
    history: history
  }));
}
function useRouter() {
  return useContext(RouterContext);
}

var _excluded$1 = ["to"];

function ownKeys$1(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$1(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$1(Object(source), true).forEach(function (key) { _defineProperty$1(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$1(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$1(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties$1(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose$1(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose$1(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function Link(_ref) {
  var to = _ref.to,
      rest = _objectWithoutProperties$1(_ref, _excluded$1);

  var router = useRouter(); // TODO: 防重复点击

  function handleClick(e) {
    e.preventDefault();
    navigate(router, to);
  }

  return (
    /*#__PURE__*/
    // eslint-disable-next-line jsx-a11y/anchor-has-content
    jsx("a", _objectSpread$1(_objectSpread$1({}, rest), {}, {
      href: createHref(router, to),
      onClick: handleClick
    }))
  );
}

var _excluded = ["to", "children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var Context = /*#__PURE__*/createContext({
  loading: false
});
function usePrefetch() {
  return useContext(Context);
}
function PrefetchLink(_ref) {
  var to = _ref.to,
      children = _ref.children,
      rest = _objectWithoutProperties(_ref, _excluded);

  var router = useRouter();
  var viewPromiseRef = useRef();

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      loading = _useState2[0],
      setLoading = _useState2[1];

  var _useState3 = useState(),
      _useState4 = _slicedToArray(_useState3, 2),
      error = _useState4[0],
      setError = _useState4[1];

  var _useState5 = useState(),
      _useState6 = _slicedToArray(_useState5, 2),
      view = _useState6[0],
      setView = _useState6[1];

  var location = toLocation(router, to);

  function prefetchIt() {
    setLoading(true);
    viewPromiseRef.current = resolve(router, location).then(function (v) {
      setView(v);
      return v;
    }).catch(function (e) {
      setError(e);
      throw e;
    }).finally(function () {
      return setLoading(false);
    });
  }

  function handlePrefetch() {
    if (viewPromiseRef.current) return;
    prefetchIt();
  }

  function handleClick(e) {
    e.preventDefault();

    if (!viewPromiseRef.current) {
      prefetchIt();
    }

    commit(router, viewPromiseRef.current, location);
  }

  useEffect(function () {
    viewPromiseRef.current = undefined;
  }, [to]);
  return /*#__PURE__*/jsx(Context.Provider, {
    value: {
      loading: loading,
      error: error,
      view: view
    },
    children: /*#__PURE__*/jsx("a", _objectSpread(_objectSpread({}, rest), {}, {
      href: createHref(router, to),
      onMouseEnter: handlePrefetch,
      onClick: handleClick,
      children: children
    }))
  });
}

export { BaseRouter, DataProvider, HashRouter, Link, LoadingContext, MemoryRouter, PrefetchLink, RouterComponent as Router, RouterContext, View, ViewProvider, back, cancel, commit, commitReplace, create, createHref, resolveView as defaultResolveView, forward, go, listen, match, navigate, refresh, resolve, resolveTo, toLocation, useData, useDataContext, useLoading, useLoadingSetter, useNamedData, usePrefetch, useRouter, useView };
//# sourceMappingURL=native-router-react.es.js.map
