import { History } from 'history';
import type { Location, Matched, Options, BaseRoute, RouterInstance, ResolveView } from './types';
export declare function create<R extends BaseRoute = BaseRoute, V = any>(routes: R | R[], history: History, resolveView: ResolveView<R, V>, options?: Options<V>): RouterInstance<R, V>;
export declare function match<R extends BaseRoute = BaseRoute>(router: RouterInstance<R>, pathname: string): Matched<R>[] | undefined;
export declare function toLocation<R extends BaseRoute = BaseRoute, V = any>(router: RouterInstance<R, V>, to: string, state?: any): Location;
export declare function resolve<R extends BaseRoute = BaseRoute, V = any>(router: RouterInstance<R, V>, location: Location): Promise<V>;
export declare function resolveTo<R extends BaseRoute = BaseRoute, V = any>(router: RouterInstance<R, V>, to: string, state?: any): Promise<V>;
export declare function commit<R extends BaseRoute = BaseRoute, V = any>(router: RouterInstance<R, V>, resolvePromise: Promise<V>, location: Location): Promise<void>;
export declare function commitReplace<R extends BaseRoute = BaseRoute, V = any>(router: RouterInstance<R, V>, resolvePromise: Promise<V>, location: Location): Promise<void>;
export declare function navigate<R extends BaseRoute = BaseRoute, V = any>(router: RouterInstance<R, V>, to: string, state?: any): Promise<void>;
export declare function refresh<R extends BaseRoute = BaseRoute, V = any>(router: RouterInstance<R, V>): Promise<void>;
export declare function go<R extends BaseRoute = BaseRoute, V = any>(router: RouterInstance<R, V>, delta: number): void;
export declare function forward<R extends BaseRoute = BaseRoute, V = any>(router: RouterInstance<R, V>): void;
export declare function back<R extends BaseRoute = BaseRoute, V = any>(router: RouterInstance<R, V>): void;
export declare function createHref<R extends BaseRoute = BaseRoute, V = any>({ baseUrl, history }: RouterInstance<R, V>, to: string): string;
export declare function cancel<R extends BaseRoute = BaseRoute, V = any>({ cancelAll, onLoadingChange }: RouterInstance<R, V>): void;
export declare function listen<R extends BaseRoute = BaseRoute, V = any>(router: RouterInstance<R, V>, onViewChange: (v: V) => void): () => void;
